
PImage base;
PFont font;

Carres[] carre=new Carres[1000000];
int nbCarres;
int tCarDepart=5;
int tCar=tCarDepart;//taille des carrs
int nbCou=16;//nb de niveaux pour RVB

int nbCx;
int nbCy;

int choixAlgo=0;

int divSpec=16;//division du spectre au cube
float[][][] denit = new float[divSpec][divSpec][divSpec];

float rapo=256/divSpec;

Palettes[] palette=new Palettes[256];

int phase=0;

String symb="!#$%&'()*+,-./0123456789:;<@>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[]^_`abcdefghijklmnopqrstuvwxyz{|}~PѪߵ!#$%&'()*+,-./0123456789:;<@>?@ABCDEFGH";

class Palettes {
  float rou;
  float ver;
  float ble;
  float fil;
  int nb;//classement

  Palettes(int nb) {
    this.nb=nb;
  }
}

class Carres {
  float x;
  float y;
  float rou;
  float ver;
  float ble;
  float rou2;
  float ver2;
  float ble2;
  int nb;
  int palUtil;//palette utilise

  Carres(float x, float y, int nb) {
    this.nb=nb;
    this.x=x;
    this.y=y;
  }

  void changeCouleur(boolean contours) {
    if (x*tCar+tCar<width&&y*tCar+tCar<height) {
      if (contours==true) {
        stroke(0);
      }
      else {
        noStroke();
      }
      rou=ver=ble=0;
      for (int i2=0;i2<sq(tCar);i2++) {
        rou+=red(base.get(((int)x*tCar)+(i2%tCar),((int)y*tCar)+(i2/tCar)));
        ver+=green(base.get(((int)x*tCar)+(i2%tCar),((int)y*tCar)+(i2/tCar)));
        ble+=blue(base.get(((int)x*tCar)+(i2%tCar),((int)y*tCar)+(i2/tCar)));
      }
      rou/=sq(tCar);
      ver/=sq(tCar);
      ble/=sq(tCar);
      float tmpCou=longueur2(rou,ver,ble,palette[0].rou,palette[0].ver,palette[0].ble);
      int tmpPal=0;
      for (int i=0;i<nbCou;i++) {
        float ecartC=longueur2(rou,ver,ble,palette[i].rou,palette[i].ver,palette[i].ble);
        if (ecartC<tmpCou) {
          tmpCou=ecartC;
          tmpPal=i;
        }
      }
      rou2=palette[tmpPal].rou;
      ver2=palette[tmpPal].ver;
      ble2=palette[tmpPal].ble;
      palette[tmpPal].fil++;
      palUtil=tmpPal;
      fill(rou2,ver2,ble2);
      rect(x*tCar,y*tCar,tCar,tCar);
    }
  }

  void nombre(boolean noir) {
    if (x*tCar+tCar<width&&y*tCar+tCar<height) {
      textFont(font, constrain(tCar,1,10));
      if (longueur2(rou2,ver2,ble2,0,0,0)>longueur2(rou2,ver2,ble2,255,255,255)) {
        fill(0);
      }
      else {
        fill(255);
      }
      if (noir==true) {
        fill(0);
      }
      text(symb.charAt(palUtil),x*tCar+(tCar/2),y*tCar+(tCar*3/4));
    }
  }

  void traceJuste() {
    if (x*tCar+tCar<width&&y*tCar+tCar<height) {
      stroke(0);
      fill(255);
      rect(x*tCar,y*tCar,tCar,tCar);
    }
  }
}

void  setup() {
  smooth();
  font = loadFont("CourierNewPSMT-12.vlw"); 
  textFont(font, 30);
  textAlign(CENTER);
  colorMode(RGB);
  base=loadImage("base.gif");
  size(base.width,base.height,JAVA2D);
  nbCx=(base.width)/tCar;
  nbCy=(base.height)/tCar;
  nbCarres=nbCx*nbCy;
  for (int i=0;i<nbCarres;i++) {
    float x=(i%nbCx);
    float y=(i/nbCx);
    Carres truc=new Carres(x,y,i);
    carre[i]=truc;
  }
  for (int i=0;i<256;i++) {
    Palettes truc2= new Palettes(i);
    palette[i]=truc2;
  }
}

void draw() {
  if (phase==0) {
    loadi();
    choixAlgoF();
  }
  else if (phase==1) {
    population();
    phase++;
  }
  else if (phase==2) {
    background(0);
    regle();
    filZero();
    approche();
    afficheNombres();
    regleaff();
    enreg();
  }
}

void filZero() {
  for (int i=0;i<256;i++) {
    palette[i].fil=0;
  }
}

void afficheNombres() {
  for (int i=0;i<nbCarres;i++) {
    carre[i].nombre(false);
  }
}

void choixAlgoF() {
  if (choixAlgo==0) {
    fill(255);
    rect (0,0,(width/2)-2,40);
    rect (width/2,0,(width/2)-2,40);
    textFont(font, 10);
    fill(0);
    text("Algo 1",width/4,20);
    text("Algo 2",width/2+width/4,20);
    if (mousePressed==true) {
      if (mouseX<width/2) {
        choixAlgo=1;
      }
      else{
        choixAlgo=2;      
      }
      loadi();
      phase++;
    }
  }
}

void loadi() {
  background(0);
  fill(255);
  text("loading",width/2,height/2);
}

void regle() {
  nbCou=constrain(mouseX*256/width,1,256);
  tCar=constrain(mouseY*40/height,tCarDepart,40);
}

void regleaff() {
  fill(255);
  stroke(0);
  rect(width-80,height-80,60,35);
  textFont(font, 30);
  fill(0);
  text(nbCou,width-50,height-50);
}

void testPalette() {
  for (int i=0;i<256;i++) {
    fill(palette[i].rou,palette[i].ver,palette[i].ble);
    rect(i*3,10,3,3);
  }
}

void population() {
  if (choixAlgo==1) {
    for (int iX=0;iX<divSpec;iX++) {
      for (int iY=0;iY<divSpec;iY++) {
        for (int iZ=0;iZ<divSpec;iZ++) {
          denit[iX][iY][iZ]=0;
          for (int i=0;i<width*height;i++) {
            denit[iX][iY][iZ]+=longueur2(red(base.pixels[i]),green(base.pixels[i]),blue(base.pixels[i]),iX*rapo,iY*rapo,iZ*rapo)/(width*height);
          }
        }
      }
    }
    float popac=0;
    int iMx=0;
    int iMy=0;
    int iMz=0;
    int iMxp=0;
    int iMyp=0;
    int iMzp=0;
    for (int i=0;i<256;i++) {
      float popmin=512;
      for (int iX=0;iX<divSpec;iX++) {
        for (int iY=0;iY<divSpec;iY++) {
          for (int iZ=0;iZ<divSpec;iZ++) {
            if (iMxp!=iX || iMyp!=iY || iMzp!=iZ) {
              if (denit[iX][iY][iZ]<popmin && denit[iX][iY][iZ]>popac) {
                iMx=iX;
                iMy=iY;
                iMz=iZ;
                popmin=denit[iX][iY][iZ];
              }
            }
          }
        }
      }
      iMxp=iMx;
      iMyp=iMy;
      iMzp=iMz;
      popac=popmin;
      palette[i].rou=iMx*rapo;
      palette[i].ver=iMy*rapo;
      palette[i].ble=iMz*rapo;
    }
  }
  if (choixAlgo==2) {
    for (int i=0;i<width*height;i++) {
      denit[floor(red(base.pixels[i])/rapo)][floor(green(base.pixels[i])/rapo)][floor(blue(base.pixels[i])/rapo)]++;
    }
    float popac=width*height;
    int iMx=0;
    int iMy=0;
    int iMz=0;
    int iMxp=0;
    int iMyp=0;
    int iMzp=0;
    for (int i=0;i<256;i++) {
      float popmin=0;
      for (int iX=0;iX<divSpec;iX++) {
        for (int iY=0;iY<divSpec;iY++) {
          for (int iZ=0;iZ<divSpec;iZ++) {
            if (iMxp!=iX || iMyp!=iY || iMzp!=iZ) {
              if (denit[iX][iY][iZ]>popmin && denit[iX][iY][iZ]<popac) {
                iMx=iX;
                iMy=iY;
                iMz=iZ;
                popmin=denit[iX][iY][iZ];
              }
            }
          }
        }
      }
      iMxp=iMx;
      iMyp=iMy;
      iMzp=iMz;
      popac=popmin;
      palette[i].rou=iMx*rapo;
      palette[i].ver=iMy*rapo;
      palette[i].ble=iMz*rapo;
    }
  }
}

void approche() {
  for (int i=0;i<nbCarres;i++) {
    carre[i].changeCouleur(true);
  }
}

void approche2() {
  for (int i=0;i<nbCarres;i++) {
    carre[i].changeCouleur(false);
  }
}

float longueur(float x2, float y2, float x, float y) {
  return sqrt(sq(x2-x)+sq(y2-y));
}

float longueur2(float x2, float y2, float z2, float x, float y, float z) {
  return sqrt(sq(sqrt(sq(x2-x)+sq(y2-y)))+sq(z2-z));
}

void affichePalettes() {
  background(255);
  for (int i=0;i<nbCou;i++) {
    int nbCol=floor((nbCou-1)/10)+1;
    float posx=floor(i/10)*width/nbCol;
    float posy=(i%10)*height/(10);
    fill(palette[i].rou,palette[i].ver,palette[i].ble);
    float tailleRec=height/10-3;
    rect(posx+1,posy+1,tailleRec,tailleRec);
    int nbArguments=5;
    textFont(font, tailleRec/nbArguments);
    textAlign(LEFT);
    fill(0);
    text(symb.charAt(i),posx+tailleRec+4,posy+tailleRec/nbArguments*1);
    text("R"+(int)palette[i].rou,posx+tailleRec+4,posy+tailleRec/nbArguments*2);
    text("V"+(int)palette[i].ver,posx+tailleRec+4,posy+tailleRec/nbArguments*3);
    text("B"+(int)palette[i].ble,posx+tailleRec+4,posy+tailleRec/nbArguments*4);
    float longFil=palette[i].fil;//longueur de fil
    text("F"+(int)longFil,posx+tailleRec+4,posy+tailleRec/nbArguments*5);
    textAlign(CENTER);
  }
}

void traceBlanc() {
  for (int i=0;i<nbCarres;i++) {
    carre[i].traceJuste();
  }
}

void enreg() {
  if (mousePressed==true) {
    background(0);
    traceBlanc();
    for (int i=0;i<nbCarres;i++) {
      carre[i].nombre(true);
    }
    save("map.tif");
    approche2();
    save("rendu.tif");
    approche();
    afficheNombres();
    save("patron.tif");
    affichePalettes();
    save("palette.tif");
  }
}
