import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; import javax.sound.midi.*; import javax.sound.midi.spi.*; import javax.sound.sampled.*; import javax.sound.sampled.spi.*; import java.util.regex.*; import javax.xml.parsers.*; import javax.xml.transform.*; import javax.xml.transform.dom.*; import javax.xml.transform.sax.*; import javax.xml.transform.stream.*; import org.xml.sax.*; import org.xml.sax.ext.*; import org.xml.sax.helpers.*; public class sketch_080306a extends PApplet {
PImage base;
PFont font;

Carres[] carre=new Carres[1000000];
int nbCarres;
int tCarDepart=5;
int tCar=tCarDepart;//taille des carr\u00e9s
int nbCou=16;//nb de niveaux pour RVB

int nbCx;
int nbCy;

int choixAlgo=0;

int divSpec=16;//division du spectre au cube
float[][][] denit = new float[divSpec][divSpec][divSpec];

float rapo=256/divSpec;

Palettes[] palette=new Palettes[256];

int phase=0;

String symb="\u00a4\u00b6\u00a7!#$%&'()*+,-./0123456789:;<@>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[]^_`abcdefghijklmnopqrstuvwxyz{|}~\u00c7\u00fc\u00e9\u00e2\u00e4\u00e0\u00e5\u00e7\u00ea\u00eb\u00e8\u00ef\u00ee\u00ec\u00e6\u00c6\u00f4\u00f6\u00f2\u00fb\u00f9\u00ff\u00a2\u00a3\u00a5P\u0192\u00e1\u00ed\u00f3\u00fa\u00f1\u00d1\u00aa\u00ba\u00bf\u00ac\u00bd\u00bc\u00a1\u00ab\u00bb\u00a6\u00df\u00b5\u00b1\u00b0\u2022\u00b7\u00b2\u20ac\u201e\u2026\u2020\u2021\u02c6\u2030\u0160\u2039\u0152\u2018\u2019\u201c\u201d\u2022\u2013\u2014\u02dc\u2122\u0161\u203a\u0153\u0178\u00a8\u00a9\u00ae\u00af\u00b3\u00b4\u00b8\u00b9\u00be\u00c0\u00c1\u00c2\u00c3\u00c4\u00c5\u00c8\u00c9\u00ca\u00cb\u00cc\u00cd\u00ce\u00cf\u00d0\u00d2\u00d3\u00d4\u00d5\u00d6\u00d7\u00d8\u00d9\u00da\u00db\u00dc\u00dd\u00de\u00e3\u00f0\u00f5\u00f7\u00f8\u00fc\u00fd\u00fe\u00a4\u00b6\u00a7!#$%&'()*+,-./0123456789:;<@>?@ABCDEFGH";

class Palettes {
  float rou;
  float ver;
  float ble;
  float fil;
  int nb;//classement

  Palettes(int nb) {
    this.nb=nb;
  }
}

class Carres {
  float x;
  float y;
  float rou;
  float ver;
  float ble;
  float rou2;
  float ver2;
  float ble2;
  int nb;
  int palUtil;//palette utilis\u00e9e

  Carres(float x, float y, int nb) {
    this.nb=nb;
    this.x=x;
    this.y=y;
  }

  public void changeCouleur(boolean contours) {
    if (x*tCar+tCar<width&&y*tCar+tCar<height) {
      if (contours==true) {
        stroke(0);
      }
      else {
        noStroke();
      }
      rou=ver=ble=0;
      for (int i2=0;i2<sq(tCar);i2++) {
        rou+=red(base.get(((int)x*tCar)+(i2%tCar),((int)y*tCar)+(i2/tCar)));
        ver+=green(base.get(((int)x*tCar)+(i2%tCar),((int)y*tCar)+(i2/tCar)));
        ble+=blue(base.get(((int)x*tCar)+(i2%tCar),((int)y*tCar)+(i2/tCar)));
      }
      rou/=sq(tCar);
      ver/=sq(tCar);
      ble/=sq(tCar);
      float tmpCou=longueur2(rou,ver,ble,palette[0].rou,palette[0].ver,palette[0].ble);
      int tmpPal=0;
      for (int i=0;i<nbCou;i++) {
        float ecartC=longueur2(rou,ver,ble,palette[i].rou,palette[i].ver,palette[i].ble);
        if (ecartC<tmpCou) {
          tmpCou=ecartC;
          tmpPal=i;
        }
      }
      rou2=palette[tmpPal].rou;
      ver2=palette[tmpPal].ver;
      ble2=palette[tmpPal].ble;
      palette[tmpPal].fil++;
      palUtil=tmpPal;
      fill(rou2,ver2,ble2);
      rect(x*tCar,y*tCar,tCar,tCar);
    }
  }

  public void nombre(boolean noir) {
    if (x*tCar+tCar<width&&y*tCar+tCar<height) {
      textFont(font, constrain(tCar,1,10));
      if (longueur2(rou2,ver2,ble2,0,0,0)>longueur2(rou2,ver2,ble2,255,255,255)) {
        fill(0);
      }
      else {
        fill(255);
      }
      if (noir==true) {
        fill(0);
      }
      text(symb.charAt(palUtil),x*tCar+(tCar/2),y*tCar+(tCar*3/4));
    }
  }

  public void traceJuste() {
    if (x*tCar+tCar<width&&y*tCar+tCar<height) {
      stroke(0);
      fill(255);
      rect(x*tCar,y*tCar,tCar,tCar);
    }
  }
}

public void  setup() {
  smooth();
  font = loadFont("CourierNewPSMT-12.vlw"); 
  textFont(font, 30);
  textAlign(CENTER);
  colorMode(RGB);
  base=loadImage("base.gif");
  size(base.width,base.height,JAVA2D);
  nbCx=(base.width)/tCar;
  nbCy=(base.height)/tCar;
  nbCarres=nbCx*nbCy;
  for (int i=0;i<nbCarres;i++) {
    float x=(i%nbCx);
    float y=(i/nbCx);
    Carres truc=new Carres(x,y,i);
    carre[i]=truc;
  }
  for (int i=0;i<256;i++) {
    Palettes truc2= new Palettes(i);
    palette[i]=truc2;
  }
}

public void draw() {
  if (phase==0) {
    loadi();
    choixAlgoF();
  }
  else if (phase==1) {
    population();
    phase++;
  }
  else if (phase==2) {
    background(0);
    regle();
    filZero();
    approche();
    afficheNombres();
    regleaff();
    enreg();
  }
}

public void filZero() {
  for (int i=0;i<256;i++) {
    palette[i].fil=0;
  }
}

public void afficheNombres() {
  for (int i=0;i<nbCarres;i++) {
    carre[i].nombre(false);
  }
}

public void choixAlgoF() {
  if (choixAlgo==0) {
    fill(255);
    rect (0,0,(width/2)-2,40);
    rect (width/2,0,(width/2)-2,40);
    textFont(font, 10);
    fill(0);
    text("Algo 1",width/4,20);
    text("Algo 2",width/2+width/4,20);
    if (mousePressed==true) {
      if (mouseX<width/2) {
        choixAlgo=1;
      }
      else{
        choixAlgo=2;      
      }
      loadi();
      phase++;
    }
  }
}

public void loadi() {
  background(0);
  fill(255);
  text("loading",width/2,height/2);
}

public void regle() {
  nbCou=constrain(mouseX*256/width,1,256);
  tCar=constrain(mouseY*40/height,tCarDepart,40);
}

public void regleaff() {
  fill(255);
  stroke(0);
  rect(width-80,height-80,60,35);
  textFont(font, 30);
  fill(0);
  text(nbCou,width-50,height-50);
}

public void testPalette() {
  for (int i=0;i<256;i++) {
    fill(palette[i].rou,palette[i].ver,palette[i].ble);
    rect(i*3,10,3,3);
  }
}

public void population() {
  if (choixAlgo==1) {
    for (int iX=0;iX<divSpec;iX++) {
      for (int iY=0;iY<divSpec;iY++) {
        for (int iZ=0;iZ<divSpec;iZ++) {
          denit[iX][iY][iZ]=0;
          for (int i=0;i<width*height;i++) {
            denit[iX][iY][iZ]+=longueur2(red(base.pixels[i]),green(base.pixels[i]),blue(base.pixels[i]),iX*rapo,iY*rapo,iZ*rapo)/(width*height);
          }
        }
      }
    }
    float popac=0;
    int iMx=0;
    int iMy=0;
    int iMz=0;
    int iMxp=0;
    int iMyp=0;
    int iMzp=0;
    for (int i=0;i<256;i++) {
      float popmin=512;
      for (int iX=0;iX<divSpec;iX++) {
        for (int iY=0;iY<divSpec;iY++) {
          for (int iZ=0;iZ<divSpec;iZ++) {
            if (iMxp!=iX || iMyp!=iY || iMzp!=iZ) {
              if (denit[iX][iY][iZ]<popmin && denit[iX][iY][iZ]>popac) {
                iMx=iX;
                iMy=iY;
                iMz=iZ;
                popmin=denit[iX][iY][iZ];
              }
            }
          }
        }
      }
      iMxp=iMx;
      iMyp=iMy;
      iMzp=iMz;
      popac=popmin;
      palette[i].rou=iMx*rapo;
      palette[i].ver=iMy*rapo;
      palette[i].ble=iMz*rapo;
    }
  }
  if (choixAlgo==2) {
    for (int i=0;i<width*height;i++) {
      denit[floor(red(base.pixels[i])/rapo)][floor(green(base.pixels[i])/rapo)][floor(blue(base.pixels[i])/rapo)]++;
    }
    float popac=width*height;
    int iMx=0;
    int iMy=0;
    int iMz=0;
    int iMxp=0;
    int iMyp=0;
    int iMzp=0;
    for (int i=0;i<256;i++) {
      float popmin=0;
      for (int iX=0;iX<divSpec;iX++) {
        for (int iY=0;iY<divSpec;iY++) {
          for (int iZ=0;iZ<divSpec;iZ++) {
            if (iMxp!=iX || iMyp!=iY || iMzp!=iZ) {
              if (denit[iX][iY][iZ]>popmin && denit[iX][iY][iZ]<popac) {
                iMx=iX;
                iMy=iY;
                iMz=iZ;
                popmin=denit[iX][iY][iZ];
              }
            }
          }
        }
      }
      iMxp=iMx;
      iMyp=iMy;
      iMzp=iMz;
      popac=popmin;
      palette[i].rou=iMx*rapo;
      palette[i].ver=iMy*rapo;
      palette[i].ble=iMz*rapo;
    }
  }
}

public void approche() {
  for (int i=0;i<nbCarres;i++) {
    carre[i].changeCouleur(true);
  }
}

public void approche2() {
  for (int i=0;i<nbCarres;i++) {
    carre[i].changeCouleur(false);
  }
}

public float longueur(float x2, float y2, float x, float y) {
  return sqrt(sq(x2-x)+sq(y2-y));
}

public float longueur2(float x2, float y2, float z2, float x, float y, float z) {
  return sqrt(sq(sqrt(sq(x2-x)+sq(y2-y)))+sq(z2-z));
}

public void affichePalettes() {
  background(255);
  for (int i=0;i<nbCou;i++) {
    int nbCol=floor((nbCou-1)/10)+1;
    float posx=floor(i/10)*width/nbCol;
    float posy=(i%10)*height/(10);
    fill(palette[i].rou,palette[i].ver,palette[i].ble);
    float tailleRec=height/10-3;
    rect(posx+1,posy+1,tailleRec,tailleRec);
    int nbArguments=5;
    textFont(font, tailleRec/nbArguments);
    textAlign(LEFT);
    fill(0);
    text(symb.charAt(i),posx+tailleRec+4,posy+tailleRec/nbArguments*1);
    text("R"+(int)palette[i].rou,posx+tailleRec+4,posy+tailleRec/nbArguments*2);
    text("V"+(int)palette[i].ver,posx+tailleRec+4,posy+tailleRec/nbArguments*3);
    text("B"+(int)palette[i].ble,posx+tailleRec+4,posy+tailleRec/nbArguments*4);
    float longFil=palette[i].fil;//longueur de fil
    text("F"+(int)longFil,posx+tailleRec+4,posy+tailleRec/nbArguments*5);
    textAlign(CENTER);
  }
}

public void traceBlanc() {
  for (int i=0;i<nbCarres;i++) {
    carre[i].traceJuste();
  }
}

public void enreg() {
  if (mousePressed==true) {
    background(0);
    traceBlanc();
    for (int i=0;i<nbCarres;i++) {
      carre[i].nombre(true);
    }
    save("map.tif");
    approche2();
    save("rendu.tif");
    approche();
    afficheNombres();
    save("patron.tif");
    affichePalettes();
    save("palette.tif");
  }
}

  static public void main(String args[]) {     PApplet.main(new String[] { "sketch_080306a" });  }}